﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Runtime.CompilerServices;
using System.Threading.Tasks;
using AutoComplete.Domain;
using System.Collections.ObjectModel;

namespace AutoComplete
{
    public class MeteringCodeLogic : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        protected MeteringcodeData model = new MeteringcodeData();

        protected string _filter;
        protected List<string> _meteringCodes = new List<string>();

        protected string _meteringFilter;
        protected ObservableCollection<MeteringData> _meteringDatas;

        public MeteringCodeLogic()
        {
            _meteringDatas = new ObservableCollection<MeteringData>();
        }

        public string Filter 
        { 
            get
            {
                return _filter;
            }
            set
            {
                if (value != _filter)
                {
                    _filter = value;
                    OnPropertyChanged();
                    //Task.Run(() => 
                    //            { 
                                    MeteringCodes = model.MeteringCodes(_filter); 
                                //});
                }
            }
        }

        public List<string> MeteringCodes
        {
            set 
            {
                _meteringCodes = value;
                OnPropertyChanged();
            }
            get 
            {
                return _meteringCodes; 
            }
        }

        public string MeteringFilter
        {
            get
            {
                return _meteringFilter;
            }
            set
            {
                if (value != _meteringFilter)
                {
                    _meteringFilter = value;
                    OnPropertyChanged();
                    //Task.Run(() =>
                    //{
                        MeteringDatas = new ObservableCollection<MeteringData>(model.MeteringDatas(_meteringFilter));
                    //});
                }
            }
        }

        public ObservableCollection<MeteringData> MeteringDatas
        {
            set
            {
                _meteringDatas = value;
                OnPropertyChanged();
            }
            get
            {
                return _meteringDatas;
            }
        }

        protected virtual void OnPropertyChanged([CallerMemberName]string propertyName = "")
        {
            if (null != PropertyChanged)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
